Index: trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/module_advect_em.F
===================================================================
--- trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/module_advect_em.F	(revision 195)
+++ trunk/MESOSCALE/LMD_MM_MARS/SRC/WRFV2/dyn_em/module_advect_em.F	(revision 196)
@@ -4012,559 +4691,4 @@
        (jte < jde-3)                ) degrade_ye = .false.
 
-!--------------- y - advection first
-
-      i_start = its
-      i_end   = MIN(ite,ide-1)
-      j_start = jts
-      j_end   = MIN(jte,jde-1)
-
-!  higher order flux has a 5 or 7 point stencil, so compute
-!  bounds so we can switch to second order flux close to the boundary
-
-      j_start_f = j_start
-      j_end_f   = j_end+1
-
-      IF(degrade_ys) then
-        j_start = MAX(jts,jds+1)
-        j_start_f = jds+3
-      ENDIF
-
-      IF(degrade_ye) then
-        j_end = MIN(jte,jde-2)
-        j_end_f = jde-3
-      ENDIF
-
-!  compute fluxes, 5th or 6th order
-
-     jp1 = 2
-     jp0 = 1
-
-     j_loop_y_flux_6 : DO j = j_start, j_end+1
-
-      IF( (j >= j_start_f ) .and. (j <= j_end_f) ) THEN
-
-        DO k=kts+1,ktf
-        DO i = i_start, i_end
-          vel = fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j)
-          fqy( i, k, jp1 ) = vel*flux6(                     &
-                  w(i,k,j-3), w(i,k,j-2), w(i,k,j-1),       &
-                  w(i,k,j  ), w(i,k,j+1), w(i,k,j+2),  vel )
-        ENDDO
-        ENDDO
-
-        k = ktf+1
-        DO i = i_start, i_end
-          vel = (2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j)
-          fqy( i, k, jp1 ) = vel*flux6(                     &
-                  w(i,k,j-3), w(i,k,j-2), w(i,k,j-1),       &
-                  w(i,k,j  ), w(i,k,j+1), w(i,k,j+2),  vel )
-        ENDDO
-
-      ELSE IF ( j == jds+1 ) THEN   ! 2nd order flux next to south boundary
-
-            DO k=kts+1,ktf
-            DO i = i_start, i_end
-              fqy(i, k, jp1) = 0.5*(fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j))*          &
-                     (w(i,k,j)+w(i,k,j-1))
-            ENDDO
-            ENDDO
-
-            k = ktf+1
-            DO i = i_start, i_end
-              fqy(i, k, jp1) = 0.5*((2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j))* &
-                     (w(i,k,j)+w(i,k,j-1))
-            ENDDO
-
-     ELSE IF  ( j == jds+2 ) THEN  ! third of 4th order flux 2 in from south boundary
-
-            DO k=kts+1,ktf
-            DO i = i_start, i_end
-              vel = fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j)
-              fqy( i, k, jp1 ) = vel*flux4(              &
-                   w(i,k,j-2),w(i,k,j-1),w(i,k,j),w(i,k,j+1),vel )
-            ENDDO
-            ENDDO
-
-            k = ktf+1
-            DO i = i_start, i_end
-              vel = (2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j)
-              fqy( i, k, jp1 ) = vel*flux4(              &
-                   w(i,k,j-2),w(i,k,j-1),w(i,k,j),w(i,k,j+1),vel )
-            ENDDO
-
-     ELSE IF ( j == jde-1 ) THEN  ! 2nd order flux next to north boundary
-
-            DO k=kts+1,ktf
-            DO i = i_start, i_end
-              fqy(i, k, jp1) = 0.5*(fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j))*      &
-                     (w(i,k,j)+w(i,k,j-1))
-            ENDDO
-            ENDDO
-
-            k = ktf+1
-            DO i = i_start, i_end
-              fqy(i, k, jp1) = 0.5*((2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j))*      &
-                     (w(i,k,j)+w(i,k,j-1))
-            ENDDO
-
-     ELSE IF ( j == jde-2 ) THEN  ! 3rd or 4th order flux 2 in from north boundary
-
-            DO k=kts+1,ktf
-            DO i = i_start, i_end
-              vel = fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j)
-              fqy( i, k, jp1 ) = vel*flux4(             &
-                   w(i,k,j-2),w(i,k,j-1),    &
-                   w(i,k,j),w(i,k,j+1),vel )
-            ENDDO
-            ENDDO
-
-            k = ktf+1
-            DO i = i_start, i_end
-              vel = (2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j)
-              fqy( i, k, jp1 ) = vel*flux4(             &
-                   w(i,k,j-2),w(i,k,j-1),    &
-                   w(i,k,j),w(i,k,j+1),vel )
-            ENDDO
-
-     ENDIF
-
-!  y flux-divergence into tendency
-
-        IF(j > j_start) THEN
-
-          DO k=kts+1,ktf+1
-          DO i = i_start, i_end
-            mrdy=msft(i,j-1)*rdy
-            tendency(i,k,j-1) = tendency(i,k,j-1) - mrdy*(fqy(i,k,jp1)-fqy(i,k,jp0))
-          ENDDO
-          ENDDO
-
-       ENDIF
-
-        jtmp = jp1
-        jp1 = jp0
-        jp0 = jtmp
-
-      ENDDO j_loop_y_flux_6
-
-!  next, x - flux divergence
-
-      i_start = its
-      i_end   = MIN(ite,ide-1)
-
-      j_start = jts
-      j_end   = MIN(jte,jde-1)
-
-!  higher order flux has a 5 or 7 point stencil, so compute
-!  bounds so we can switch to second order flux close to the boundary
-
-      i_start_f = i_start
-      i_end_f   = i_end+1
-
-      IF(degrade_xs) then
-        i_start = MAX(ids+1,its)
-        i_start_f = i_start+2
-      ENDIF
-
-      IF(degrade_xe) then
-        i_end = MIN(ide-2,ite)
-        i_end_f = ide-3
-      ENDIF
-
-!  compute fluxes
-
-      DO j = j_start, j_end
-
-!  5th or 6th order flux
-
-        DO k=kts+1,ktf
-        DO i = i_start_f, i_end_f
-          vel = fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j)
-          fqx( i,k ) = vel*flux6( w(i-3,k,j), w(i-2,k,j),  &
-                                         w(i-1,k,j), w(i  ,k,j),  &
-                                         w(i+1,k,j), w(i+2,k,j),  &
-                                         vel                             )
-        ENDDO
-        ENDDO
-
-        k = ktf+1
-        DO i = i_start_f, i_end_f
-          vel = (2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j)
-          fqx( i,k ) = vel*flux6( w(i-3,k,j), w(i-2,k,j),  &
-                                         w(i-1,k,j), w(i  ,k,j),  &
-                                         w(i+1,k,j), w(i+2,k,j),  &
-                                         vel                             )
-        ENDDO
-
-!  lower order fluxes close to boundaries (if not periodic or symmetric)
-
-        IF( degrade_xs ) THEN
-
-          IF( i_start == ids+1 ) THEN ! second order flux next to the boundary
-            i = ids+1
-            DO k=kts+1,ktf
-              fqx(i,k) = 0.5*(fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j)) &
-                     *(w(i,k,j)+w(i-1,k,j))
-            ENDDO
-              k = ktf+1
-              fqx(i,k) = 0.5*((2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j)) &
-                     *(w(i,k,j)+w(i-1,k,j))
-          ENDIF
-
-          DO k=kts+1,ktf
-            i = i_start+1
-            vel = fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j)
-            fqx( i,k ) = vel*flux4( w(i-2,k,j), w(i-1,k,j),  &
-                                          w(i  ,k,j), w(i+1,k,j),  &
-                                          vel                     )
-          ENDDO
-
-            k = ktf+1
-            vel = (2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j)
-            fqx( i,k ) = vel*flux4( w(i-2,k,j), w(i-1,k,j),  &
-                                          w(i  ,k,j), w(i+1,k,j),  &
-                                          vel                     )
-        ENDIF
-
-        IF( degrade_xe ) THEN
-
-          IF( i_end == ide-2 ) THEN ! second order flux next to the boundary
-            i = ide-1
-            DO k=kts+1,ktf
-              fqx(i,k) = 0.5*(fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j))      &
-                     *(w(i,k,j)+w(i-1,k,j))
-            ENDDO
-              k = ktf+1
-              fqx(i,k) = 0.5*((2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j))      &
-                     *(w(i,k,j)+w(i-1,k,j))
-          ENDIF
-
-          i = ide-2
-          DO k=kts+1,ktf
-            vel = fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j)
-            fqx( i,k ) = vel*flux4( w(i-2,k,j), w(i-1,k,j),  &
-                                          w(i  ,k,j), w(i+1,k,j),  &
-                                          vel                             )
-          ENDDO
-
-            k = ktf+1
-            vel = (2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j)
-            fqx( i,k ) = vel*flux4( w(i-2,k,j), w(i-1,k,j),  &
-                                          w(i  ,k,j), w(i+1,k,j),  &
-                                          vel                             )
-        ENDIF
-
-!  x flux-divergence into tendency
-
-        DO k=kts+1,ktf+1
-          DO i = i_start, i_end
-            mrdx=msft(i,j)*rdx
-            tendency(i,k,j) = tendency(i,k,j) - mrdx*(fqx(i+1,k)-fqx(i,k))
-          ENDDO
-        ENDDO
-
-      ENDDO
-
-
-ELSE IF (horz_order == 5 ) THEN
-
-!  determine boundary mods for flux operators
-!  We degrade the flux operators from 3rd/4th order
-!   to second order one gridpoint in from the boundaries for
-!   all boundary conditions except periodic and symmetry - these
-!   conditions have boundary zone data fill for correct application
-!   of the higher order flux stencils
-
-   degrade_xs = .true.
-   degrade_xe = .true.
-   degrade_ys = .true.
-   degrade_ye = .true.
-
-   IF( config_flags%periodic_x   .or. &
-       config_flags%symmetric_xs .or. &
-       (its > ids+2)                ) degrade_xs = .false.
-   IF( config_flags%periodic_x   .or. &
-       config_flags%symmetric_xe .or. &
-       (ite < ide-3)                ) degrade_xe = .false.
-   IF( config_flags%periodic_y   .or. &
-       config_flags%symmetric_ys .or. &
-       (jts > jds+2)                ) degrade_ys = .false.
-   IF( config_flags%periodic_y   .or. &
-       config_flags%symmetric_ye .or. &
-       (jte < jde-3)                ) degrade_ye = .false.
-
-!--------------- y - advection first
-
-      i_start = its
-      i_end   = MIN(ite,ide-1)
-      j_start = jts
-      j_end   = MIN(jte,jde-1)
-
-!  higher order flux has a 5 or 7 point stencil, so compute
-!  bounds so we can switch to second order flux close to the boundary
-
-      j_start_f = j_start
-      j_end_f   = j_end+1
-
-      IF(degrade_ys) then
-        j_start = MAX(jts,jds+1)
-        j_start_f = jds+3
-      ENDIF
-
-      IF(degrade_ye) then
-        j_end = MIN(jte,jde-2)
-        j_end_f = jde-3
-      ENDIF
-
-!  compute fluxes, 5th or 6th order
-
-     jp1 = 2
-     jp0 = 1
-
-     j_loop_y_flux_5 : DO j = j_start, j_end+1
-
-      IF( (j >= j_start_f ) .and. (j <= j_end_f) ) THEN
-
-        DO k=kts+1,ktf
-        DO i = i_start, i_end
-          vel = fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j)
-          fqy( i, k, jp1 ) = vel*flux5(                     &
-                  w(i,k,j-3), w(i,k,j-2), w(i,k,j-1),       &
-                  w(i,k,j  ), w(i,k,j+1), w(i,k,j+2),  vel )
-        ENDDO
-        ENDDO
-
-        k = ktf+1
-        DO i = i_start, i_end
-          vel = (2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j)
-          fqy( i, k, jp1 ) = vel*flux5(                     &
-                  w(i,k,j-3), w(i,k,j-2), w(i,k,j-1),       &
-                  w(i,k,j  ), w(i,k,j+1), w(i,k,j+2),  vel )
-        ENDDO
-
-      ELSE IF ( j == jds+1 ) THEN   ! 2nd order flux next to south boundary
-
-            DO k=kts+1,ktf
-            DO i = i_start, i_end
-              fqy(i, k, jp1) = 0.5*(fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j))*          &
-                     (w(i,k,j)+w(i,k,j-1))
-            ENDDO
-            ENDDO
-
-            k = ktf+1
-            DO i = i_start, i_end
-              fqy(i, k, jp1) = 0.5*((2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j))*          &
-                     (w(i,k,j)+w(i,k,j-1))
-            ENDDO
-
-     ELSE IF  ( j == jds+2 ) THEN  ! third of 4th order flux 2 in from south boundary
-
-            DO k=kts+1,ktf
-            DO i = i_start, i_end
-              vel = fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j)
-              fqy( i, k, jp1 ) = vel*flux3(              &
-                   w(i,k,j-2),w(i,k,j-1),w(i,k,j),w(i,k,j+1),vel )
-            ENDDO
-            ENDDO
-
-            k = ktf+1
-            DO i = i_start, i_end
-              vel = (2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j)
-              fqy( i, k, jp1 ) = vel*flux3(              &
-                   w(i,k,j-2),w(i,k,j-1),w(i,k,j),w(i,k,j+1),vel )
-            ENDDO
-
-     ELSE IF ( j == jde-1 ) THEN  ! 2nd order flux next to north boundary
-
-            DO k=kts+1,ktf
-            DO i = i_start, i_end
-              fqy(i, k, jp1) = 0.5*(fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j))*      &
-                     (w(i,k,j)+w(i,k,j-1))
-            ENDDO
-            ENDDO
-
-            k = ktf+1
-            DO i = i_start, i_end
-              fqy(i, k, jp1) = 0.5*((2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j))*      &
-                     (w(i,k,j)+w(i,k,j-1))
-            ENDDO
-
-     ELSE IF ( j == jde-2 ) THEN  ! 3rd or 4th order flux 2 in from north boundary
-
-            DO k=kts+1,ktf
-            DO i = i_start, i_end
-              vel = fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j)
-              fqy( i, k, jp1 ) = vel*flux3(             &
-                   w(i,k,j-2),w(i,k,j-1),    &
-                   w(i,k,j),w(i,k,j+1),vel )
-            ENDDO
-            ENDDO
-
-            k = ktf+1
-            DO i = i_start, i_end
-              vel = (2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j)
-              fqy( i, k, jp1 ) = vel*flux3(             &
-                   w(i,k,j-2),w(i,k,j-1),    &
-                   w(i,k,j),w(i,k,j+1),vel )
-            ENDDO
-
-     ENDIF
-
-!  y flux-divergence into tendency
-
-        IF(j > j_start) THEN
-
-          DO k=kts+1,ktf+1
-          DO i = i_start, i_end
-            mrdy=msft(i,j-1)*rdy
-            tendency(i,k,j-1) = tendency(i,k,j-1) - mrdy*(fqy(i,k,jp1)-fqy(i,k,jp0))
-          ENDDO
-          ENDDO
-
-       ENDIF
-
-        jtmp = jp1
-        jp1 = jp0
-        jp0 = jtmp
-
-      ENDDO j_loop_y_flux_5
-
-!  next, x - flux divergence
-
-      i_start = its
-      i_end   = MIN(ite,ide-1)
-
-      j_start = jts
-      j_end   = MIN(jte,jde-1)
-
-!  higher order flux has a 5 or 7 point stencil, so compute
-!  bounds so we can switch to second order flux close to the boundary
-
-      i_start_f = i_start
-      i_end_f   = i_end+1
-
-      IF(degrade_xs) then
-        i_start = MAX(ids+1,its)
-        i_start_f = i_start+2
-      ENDIF
-
-      IF(degrade_xe) then
-        i_end = MIN(ide-2,ite)
-        i_end_f = ide-3
-      ENDIF
-
-!  compute fluxes
-
-      DO j = j_start, j_end
-
-!  5th or 6th order flux
-
-        DO k=kts+1,ktf
-        DO i = i_start_f, i_end_f
-          vel = fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j)
-          fqx( i,k ) = vel*flux5( w(i-3,k,j), w(i-2,k,j),  &
-                                  w(i-1,k,j), w(i  ,k,j),  &
-                                  w(i+1,k,j), w(i+2,k,j),  &
-                          vel                             )
-        ENDDO
-        ENDDO
-
-        k = ktf+1
-        DO i = i_start_f, i_end_f
-          vel = (2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j)
-          fqx( i,k ) = vel*flux5( w(i-3,k,j), w(i-2,k,j),  &
-                                  w(i-1,k,j), w(i  ,k,j),  &
-                                  w(i+1,k,j), w(i+2,k,j),  &
-                          vel                             )
-        ENDDO
-
-!  lower order fluxes close to boundaries (if not periodic or symmetric)
-
-        IF( degrade_xs ) THEN
-
-          IF( i_start == ids+1 ) THEN ! second order flux next to the boundary
-            i = ids+1
-            DO k=kts+1,ktf
-              fqx(i,k) = 0.5*(fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j)) &
-                     *(w(i,k,j)+w(i-1,k,j))
-            ENDDO
-              k = ktf+1
-              fqx(i,k) = 0.5*((2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j)) &
-                     *(w(i,k,j)+w(i-1,k,j))
-          ENDIF
-
-          i = i_start+1
-          DO k=kts+1,ktf
-            vel = fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j)
-            fqx( i,k ) = vel*flux3( w(i-2,k,j), w(i-1,k,j),  &
-                                    w(i  ,k,j), w(i+1,k,j),  &
-                                          vel                     )
-          ENDDO
-            k = ktf+1
-            vel = (2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j)
-            fqx( i,k ) = vel*flux3( w(i-2,k,j), w(i-1,k,j),  &
-                                    w(i  ,k,j), w(i+1,k,j),  &
-                                          vel                     )
-
-        ENDIF
-
-        IF( degrade_xe ) THEN
-
-          IF( i_end == ide-2 ) THEN ! second order flux next to the boundary
-            i = ide-1
-            DO k=kts+1,ktf
-              fqx(i,k) = 0.5*(fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j))      &
-                     *(w(i,k,j)+w(i-1,k,j))
-            ENDDO
-              k = ktf+1
-              fqx(i,k) = 0.5*((2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j))      &
-                     *(w(i,k,j)+w(i-1,k,j))
-          ENDIF
-
-          i = ide-2
-          DO k=kts+1,ktf
-            vel = fzm(k)*ru(i,k,j)+fzp(k)*ru(i,k-1,j)
-            fqx( i,k ) = vel*flux3( w(i-2,k,j), w(i-1,k,j),  &
-                                          w(i  ,k,j), w(i+1,k,j),  &
-                                          vel                             )
-          ENDDO
-            k = ktf+1
-            vel = (2.-fzm(k-1))*ru(i,k-1,j)-fzp(k-1)*ru(i,k-2,j)
-            fqx( i,k ) = vel*flux3( w(i-2,k,j), w(i-1,k,j),  &
-                                          w(i  ,k,j), w(i+1,k,j),  &
-                                          vel                             )
-        ENDIF
-
-!  x flux-divergence into tendency
-
-        DO k=kts+1,ktf+1
-          DO i = i_start, i_end
-            mrdx=msft(i,j)*rdx
-            tendency(i,k,j) = tendency(i,k,j) - mrdx*(fqx(i+1,k)-fqx(i,k))
-          ENDDO
-        ENDDO
-
-      ENDDO
-
-ELSE IF ( horz_order == 4 ) THEN
-
-   degrade_xs = .true.
-   degrade_xe = .true.
-   degrade_ys = .true.
-   degrade_ye = .true.
-
-   IF( config_flags%periodic_x   .or. &
-       config_flags%symmetric_xs .or. &
-       (its > ids+1)                ) degrade_xs = .false.
-   IF( config_flags%periodic_x   .or. &
-       config_flags%symmetric_xe .or. &
-       (ite < ide-2)                ) degrade_xe = .false.
-   IF( config_flags%periodic_y   .or. &
-       config_flags%symmetric_ys .or. &
-       (jts > jds+1)                ) degrade_ys = .false.
-   IF( config_flags%periodic_y   .or. &
-       config_flags%symmetric_ye .or. &
-       (jte < jde-2)                ) degrade_ye = .false.
-
 !  begin flux computations
 !  start with x flux divergence
@@ -4676,4 +4800,5 @@
       ENDIF
 
+
         jp1 = 2
         jp0 = 1
@@ -4698,14 +4823,22 @@
           DO k = kts+1, ktf
           DO i = i_start, i_end
+            ! Assumes j>j_end_f is ONLY j_end+1 ...
+!            fqy(i, k, jp1) =                             &
+!               0.5*(fzm(k)*rv(i,k,j_end+1)+fzp(k)*rv(i,k-1,j_end+1))     &
+!                   *(w(i,k,j_end+1)+w(i,k,j_end))
             fqy(i, k, jp1) =                             &
-               0.5*(fzm(k)*rv(i,k,j_end+1)+fzp(k)*rv(i,k-1,j_end+1))     &
-                   *(w(i,k,j_end+1)+w(i,k,j_end))
+               0.5*(fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j))     &
+                   *(w(i,k,j)+w(i,k,j-1))
           ENDDO
           ENDDO
           k = ktf+1
           DO i = i_start, i_end
+            ! Assumes j>j_end_f is ONLY j_end+1 ...
+!            fqy(i, k, jp1) =                                         &
+!               0.5*((2.-fzm(k-1))*rv(i,k-1,j_end+1)-fzp(k-1)*rv(i,k-2,j_end+1))     &
+!                   *(w(i,k,j_end+1)+w(i,k,j_end))
             fqy(i, k, jp1) =                                         &
-               0.5*((2.-fzm(k-1))*rv(i,k-1,j_end+1)-fzp(k-1)*rv(i,k-2,j_end+1))     &
-                   *(w(i,k,j_end+1)+w(i,k,j_end))
+               0.5*((2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j))     &
+                   *(w(i,k,j)+w(i,k,j-1))
           ENDDO
        ELSE
@@ -4728,6 +4861,7 @@
        END IF
 
+!  y flux-divergence into tendency
        IF( j > j_start ) THEN
-!  y flux-divergence into tendency
+
           DO k = kts+1, ktf+1
           DO i = i_start, i_end
@@ -4736,4 +4870,6 @@
           ENDDO
           ENDDO
+
+
        END IF
 
@@ -4753,5 +4889,5 @@
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xs .or. &
-       (its > ids+1)                ) degrade_xs = .false.
+       (its > ids+2)                ) degrade_xs = .false.
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xe .or. &
@@ -4759,8 +4895,8 @@
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ys .or. &
-       (jts > jds+1)                ) degrade_ys = .false.
+       (jts > jds+2)                ) degrade_ys = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ye .or. &
-       (jte < jde-2)                ) degrade_ye = .false.
+       (jte < jde-3)                ) degrade_ye = .false.
 
 !  begin flux computations
@@ -4873,4 +5009,5 @@
       ENDIF
 
+
         jp1 = 2
         jp0 = 1
@@ -4895,14 +5032,22 @@
           DO k = kts+1, ktf
           DO i = i_start, i_end
+            ! Assumes j>j_end_f is ONLY j_end+1 ...
+!            fqy(i, k, jp1) =                             &
+!               0.5*(fzm(k)*rv(i,k,j_end+1)+fzp(k)*rv(i,k-1,j_end+1))     &
+!                   *(w(i,k,j_end+1)+w(i,k,j_end))
             fqy(i, k, jp1) =                             &
-               0.5*(fzm(k)*rv(i,k,j_end+1)+fzp(k)*rv(i,k-1,j_end+1))     &
-                   *(w(i,k,j_end+1)+w(i,k,j_end))
+               0.5*(fzm(k)*rv(i,k,j)+fzp(k)*rv(i,k-1,j))     &
+                   *(w(i,k,j)+w(i,k,j-1))
           ENDDO
           ENDDO
           k = ktf+1
           DO i = i_start, i_end
+            ! Assumes j>j_end_f is ONLY j_end+1 ...
+!            fqy(i, k, jp1) =                             &
+!               0.5*((2.-fzm(k-1))*rv(i,k-1,j_end+1)-fzp(k-1)*rv(i,k-2,j_end+1))     &
+!                   *(w(i,k,j_end+1)+w(i,k,j_end))
             fqy(i, k, jp1) =                             &
-               0.5*((2.-fzm(k-1))*rv(i,k-1,j_end+1)-fzp(k-1)*rv(i,k-2,j_end+1))     &
-                   *(w(i,k,j_end+1)+w(i,k,j_end))
+               0.5*((2.-fzm(k-1))*rv(i,k-1,j)-fzp(k-1)*rv(i,k-2,j))     &
+                   *(w(i,k,j)+w(i,k,j-1))
           ENDDO
        ELSE
@@ -4925,6 +5070,7 @@
        END IF
 
+!  y flux-divergence into tendency
        IF( j > j_start ) THEN
-!  y flux-divergence into tendency
+
           DO k = kts+1, ktf+1
           DO i = i_start, i_end
@@ -4933,4 +5079,6 @@
           ENDDO
           ENDDO
+
+
        END IF
 
@@ -4985,4 +5133,5 @@
       i_start = its
       i_end   = MIN(ite,ide-1)
+      !
       IF ( config_flags%open_ys .or. specified ) j_start = MAX(jds+1,jts)
       IF ( config_flags%open_ye .or. specified ) j_end   = MIN(jde-2,jte)
@@ -5017,4 +5166,8 @@
 
       ENDDO
+
+   ELSE IF ( horz_order == 0 ) THEN
+
+      ! Just in case we want to turn horizontal advection off, we can do it
 
    ELSE
@@ -5501,4 +5654,7 @@
       flux_upwind(q_im1, q_i, cr ) = 0.5*min( 1.0,(cr+abs(cr)))*q_im1 &
                                     +0.5*max(-1.0,(cr-abs(cr)))*q_i
+
+!      flux_upwind(q_im1, q_i, cr ) = 0.5*(1.+sign(1.,cr))*q_im1 &
+!                                    +0.5*(1.-sign(1.,cr))*q_i
 !      flux_upwind(q_im1, q_i, cr ) = 0.
 
@@ -5535,14 +5691,14 @@
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xs .or. &
-       (its > ids+2)                ) degrade_xs = .false.
+       (its > ids+3)                ) degrade_xs = .false.
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xe .or. &
-       (ite < ide-3)                ) degrade_xe = .false.
+       (ite < ide-4)                ) degrade_xe = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ys .or. &
-       (jts > jds+2)                ) degrade_ys = .false.
+       (jts > jds+3)                ) degrade_ys = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ye .or. &
-       (jte < jde-3)                ) degrade_ye = .false.
+       (jte < jde-4)                ) degrade_ye = .false.
 
 !--------------- y - advection first
@@ -5560,14 +5716,16 @@
 !--  modify loop bounds if open or specified
 
-      IF(degrade_xs) i_start = its
-      IF(degrade_xe) i_end   = MIN(ite,ide-1)
+!      IF(degrade_xs) i_start = MAX(its-1,ids-1)
+!      IF(degrade_xe) i_end   = MIN(ite+1,ide-2)
+      IF(degrade_xs) i_start = MAX(its-1,ids)
+      IF(degrade_xe) i_end   = MIN(ite+1,ide-1)
 
       IF(degrade_ys) then
-        j_start = MAX(jts,jds+1)
+        j_start = MAX(jts-1,jds+1)
         j_start_f = jds+3
       ENDIF
 
       IF(degrade_ye) then
-        j_end = MIN(jte,jde-2)
+        j_end = MIN(jte+1,jde-2)
         j_end_f = jde-3
       ENDIF
@@ -5652,5 +5810,5 @@
             ENDDO
 
-      ELSE IF ( j == jde-2 ) THEN  ! 4th order flux 2 in from north boundary
+      ELSE IF ( j == jde-2 ) THEN  ! 3rd or 4th order flux 2 in from north boundary
 
             DO k=kts,ktf
@@ -5673,5 +5831,5 @@
       ENDIF
 
-    ENDDO j_loop_y_flux_6
+   ENDDO j_loop_y_flux_6
 
 !  next, x flux
@@ -5689,14 +5847,16 @@
 !--  modify loop bounds for open and specified b.c
 
-      IF(degrade_ys) j_start = jts
-      IF(degrade_ye) j_end   = MIN(jte,jde-1)
+!      IF(degrade_ys) j_start = MAX(jts-1,jds+1)
+!      IF(degrade_ye) j_end   = MIN(jte+1,jde-2)
+      IF(degrade_ys) j_start = MAX(jts-1,jds)
+      IF(degrade_ye) j_end   = MIN(jte+1,jde-1)
 
       IF(degrade_xs) then
-        i_start = MAX(ids+1,its)
-        i_start_f = i_start+2
+        i_start = MAX(ids+1,its-1)
+        i_start_f = ids+3
       ENDIF
 
       IF(degrade_xe) then
-        i_end = MIN(ide-2,ite)
+        i_end = MIN(ide-2,ite+1)
         i_end_f = ide-3
       ENDIF
@@ -5706,5 +5866,5 @@
       DO j = j_start, j_end
 
-!  6th order flux
+!  5th order flux
 
         DO k=kts,ktf
@@ -5730,67 +5890,68 @@
         IF( degrade_xs ) THEN
 
-          IF( i_start == ids+1 ) THEN ! second order flux next to the boundary
-            i = ids+1
-            DO k=kts,ktf
-
-              dx = 2./(msft(i,j)+msft(i-1,j))/rdx
-              mu = 0.5*(mut(i,j)+mut(i-1,j))
-              vel = ru(i,k,j)/mu
-              cr = vel*dt/dx
-              fqxl(i,k,j) = mu*(dx/dt)*flux_upwind(field_old(i-1,k,j), field_old(i,k,j  ), cr)
-
-              fqx(i,k,j) = 0.5*(ru(i,k,j)) &
-                     *(field(i,k,j)+field(i-1,k,j))
-
-              fqx(i,k,j) = fqx(i,k,j) - fqxl(i,k,j)
-
-            ENDDO
-          ENDIF
-
-          i = ids+2
-          DO k=kts,ktf
-            dx = 2./(msft(i,j)+msft(i-1,j))/rdx
-            mu = 0.5*(mut(i,j)+mut(i-1,j))
-            vel = ru(i,k,j)
-            cr = vel*dt/dx/mu
-            fqxl(i,k,j) = mu*(dx/dt)*flux_upwind(field_old(i-1,k,j), field_old(i,k,j  ), cr)
-            fqx( i,k,j ) = vel*flux4( field(i-2,k,j), field(i-1,k,j),  &
-                                          field(i  ,k,j), field(i+1,k,j),  &
-                                          vel                     )
-            fqx(i,k,j) = fqx(i,k,j) - fqxl(i,k,j)
-
-          ENDDO
-
-        ENDIF
-
-        IF( degrade_xe ) THEN
-
-          IF( i_end == ide-2 ) THEN ! second order flux next to the boundary
-            i = ide-1
-            DO k=kts,ktf
-              dx = 2./(msft(i,j)+msft(i-1,j))/rdx
-              mu = 0.5*(mut(i,j)+mut(i-1,j))
-              vel = ru(i,k,j)
-              cr = vel*dt/dx/mu
-              fqxl(i,k,j) = mu*(dx/dt)*flux_upwind(field_old(i-1,k,j), field_old(i,k,j  ), cr)
-              fqx(i,k,j) = 0.5*(ru(i,k,j))      &
-                     *(field(i,k,j)+field(i-1,k,j))
-              fqx(i,k,j) = fqx(i,k,j) - fqxl(i,k,j)
-
-            ENDDO
-          ENDIF
-
-          i = ide-2
-          DO k=kts,ktf
-
-            dx = 2./(msft(i,j)+msft(i-1,j))/rdx
-            mu = 0.5*(mut(i,j)+mut(i-1,j))
-            vel = ru(i,k,j)
-            cr = vel*dt/dx/mu
-            fqxl(i,k,j) = mu*(dx/dt)*flux_upwind(field_old(i-1,k,j), field_old(i,k,j  ), cr)
-            fqx( i,k,j ) = vel*flux4( field(i-2,k,j), field(i-1,k,j),  &
+          DO i=i_start,i_start_f-1
+
+            IF(i == ids+1) THEN ! second order
+              DO k=kts,ktf
+                dx = 2./(msft(i,j)+msft(i-1,j))/rdx
+                mu = 0.5*(mut(i,j)+mut(i-1,j))
+                vel = ru(i,k,j)/mu
+                cr = vel*dt/dx
+                fqxl(i,k,j) = mu*(dx/dt)*flux_upwind(field_old(i-1,k,j), field_old(i,k,j  ), cr)
+                fqx(i,k,j) = 0.5*(ru(i,k,j)) &
+                       *(field(i,k,j)+field(i-1,k,j))
+                fqx(i,k,j) = fqx(i,k,j) - fqxl(i,k,j)
+              ENDDO
+            ENDIF
+
+            IF(i == ids+2) THEN  ! fourth order
+              DO k=kts,ktf
+                dx = 2./(msft(i,j)+msft(i-1,j))/rdx
+                mu = 0.5*(mut(i,j)+mut(i-1,j))
+                vel = ru(i,k,j)
+                cr = vel*dt/dx/mu
+                fqxl(i,k,j) = mu*(dx/dt)*flux_upwind(field_old(i-1,k,j), field_old(i,k,j  ), cr)
+                fqx( i,k,j ) = vel*flux4( field(i-2,k,j), field(i-1,k,j),  &
                                           field(i  ,k,j), field(i+1,k,j),  &
                                           vel                             )
-            fqx(i,k,j) = fqx(i,k,j) - fqxl(i,k,j)
+                fqx(i,k,j) = fqx(i,k,j) - fqxl(i,k,j)
+              ENDDO
+            ENDIF
+
+          ENDDO
+
+        ENDIF
+
+        IF( degrade_xe ) THEN
+
+          DO i = i_end_f+1, i_end+1
+
+            IF( i == ide-1 ) THEN ! second order flux next to the boundary
+              DO k=kts,ktf
+                dx = 2./(msft(i,j)+msft(i-1,j))/rdx
+                mu = 0.5*(mut(i,j)+mut(i-1,j))
+                vel = ru(i,k,j)
+                cr = vel*dt/dx/mu
+                fqxl(i,k,j) = mu*(dx/dt)*flux_upwind(field_old(i-1,k,j), field_old(i,k,j  ), cr)
+                fqx(i,k,j) = 0.5*(ru(i,k,j))      &
+                       *(field(i,k,j)+field(i-1,k,j))
+                fqx(i,k,j) = fqx(i,k,j) - fqxl(i,k,j)
+              ENDDO
+            ENDIF
+
+
+            IF( i == ide-2 ) THEN ! fourth order flux one in from the boundary
+              DO k=kts,ktf
+                dx = 2./(msft(i,j)+msft(i-1,j))/rdx
+                mu = 0.5*(mut(i,j)+mut(i-1,j))
+                vel = ru(i,k,j)
+                cr = vel*dt/dx/mu
+                fqxl(i,k,j) = mu*(dx/dt)*flux_upwind(field_old(i-1,k,j), field_old(i,k,j  ), cr)
+                fqx( i,k,j ) = vel*flux4( field(i-2,k,j), field(i-1,k,j),  &
+                                          field(i  ,k,j), field(i+1,k,j),  &
+                                          vel                             )
+                fqx(i,k,j) = fqx(i,k,j) - fqxl(i,k,j)
+              ENDDO
+            ENDIF
 
           ENDDO
@@ -5806,14 +5967,14 @@
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xs .or. &
-       (its > ids+2)                ) degrade_xs = .false.
+       (its > ids+3)                ) degrade_xs = .false.
    IF( config_flags%periodic_x   .or. &
        config_flags%symmetric_xe .or. &
-       (ite < ide-3)                ) degrade_xe = .false.
+       (ite < ide-4)                ) degrade_xe = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ys .or. &
-       (jts > jds+2)                ) degrade_ys = .false.
+       (jts > jds+3)                ) degrade_ys = .false.
    IF( config_flags%periodic_y   .or. &
        config_flags%symmetric_ye .or. &
-       (jte < jde-3)                ) degrade_ye = .false.
+       (jte < jde-4)                ) degrade_ye = .false.
 
 !--------------- y - advection first
